
QGIS Application - Bug report #11863

invalid sld for graduated style on field with negative values

2014-12-15 05:58 AM - Maarten Pronk

Status: Closed

Priority: Normal

Assignee:

Category: Expressions

Affected QGIS version:2.6.1 Regression?: No

Operating System: Linux, Windows Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 20078

Description

When creating a graduated style on a field with negative values, the resulting sld file has the following xml:

&lt;ogc:PropertyIsLessThanOrEqualTo&gt;

                &lt;ogc:PropertyName&gt;value&lt;/ogc:PropertyName&gt;

                &lt;ogc:Literal&gt;-&lt;ogc:Literal&gt;0.786648&lt;/ogc:Literal&gt;

                &lt;/ogc:Literal&gt;

              &lt;/ogc:PropertyIsLessThanOrEqualTo&gt;

The sld has a Literal within a Literal. Loading the same sld back into QGIS produces rules with || like:

value > '-' || 4.45316 AND value <= '-' || 0.786648

Which results in the same visualization for all negative fields.

Affects 2.4 to 2.6.1, probably also older versions. Tested on different layers, with different fields on Windows & Linux.

Associated revisions

Revision f800ac63 - 2015-05-04 12:26 PM - Martin Dobias

Merge pull request #1975 from rduivenvoorde/sldfix_11863

Fixes #11863 (invalid SLD with negative values)

History

#1 - 2015-03-30 02:42 AM - Richard Duivenvoorde

- Target version set to Version 2.8.2

- Category changed from Symbology to Expressions

- File issue.zip added

I've been trying to debug this, and it appears that for the creation of the sld qgsexpression is used.

And after the parsing of an expression string like:

foo > -0.01 AND foo <= -0.001

the minus signs are seen/parsed as unary operators instead of a minus+doube

adding an example project so hopefully somebody more into this part of the code is able to debug/fix it better
#2 - 2015-04-03 02:32 AM - Richard Duivenvoorde

According to others it is not the parsing that is the problem, 

it is the xml/sld generation which does not take the unary-minus into account.

https://github.com/qgis/QGIS/pull/1975

is my try to fix this...

#3 - 2015-05-04 03:30 AM - Martin Dobias

- Status changed from Open to Closed

Fixed in changeset commit:"f800ac635b9f98d53becb721a1fd8f27c233a55c".

#4 - 2015-05-08 08:13 AM - Richard Duivenvoorde

- Target version changed from Version 2.8.2 to Version 2.10

Files

issue.zip 11.1 KB 2015-03-30 Richard Duivenvoorde
